<template>
    <bit-header title="Meet our friends"></bit-header>
    <div class="container">
        <div class="row">
            <div class="col-sm-12 col-xl-6 col-xxl-4" v-for="( friend, index ) in   friends  " :key="friend.id">
                <friend-card @click="goToProfile(friend.id)" :friend=friend :lastElement="index === friends.length - 1"
                    :lastRowOnXXL="isOnLastRowXXL(friends.length, index)" />
            </div>
        </div>
    </div>
</template>


<script>

import axios from "axios";
import { defineComponent, ref } from "vue";
import FriendCard from './FriendCard.vue'
import BitHeader from './BitHeader.vue';
import router from '../router';

export default defineComponent({
    components: {
        FriendCard,
        BitHeader,
    },
    name: 'Friends',
    setup() {
        const friends = ref([]);
        axios.get("https://rickandmortyapi.com/api/character/1,3,4,6,141,819").then(response => {
            friends.value = response.data
        });

        const isOnLastRowXXL = (length, index) => {
            if (!length) {
                return;
            }
            let availableIndex = [];
            switch (length % 3) {
                case 0:
                    availableIndex = [length - 1, length - 2, length - 3];
                    break
                case 1:
                    availableIndex = [length - 1];
                    break;
                case 2:
                    availableIndex = [length - 1, length - 2];
                    break
                default:
                    break;
            }
            return availableIndex.includes(index);
        }

        const goToProfile = (id) => {
            router.push(`/friends/profile/${id}`)
        }

        return {
            friends,
            isOnLastRowXXL,
            goToProfile
        }
    }
})

</script>


<style scoped lang="scss">
.container {
    margin: 3em auto 0;
    overflow-y: auto;
    overflow-x: hidden;
    max-height: 95%;
    max-width: unset;
    border-radius: 0.8em;
}

@media screen and (min-width: 1700px) {
    .row {
        margin: 0 7em;
    }
}
</style>